"{ Package: 'stx:libjava' }"

JavaClassReader subclass:#JavaClassReader2
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Support'
!


!JavaClassReader2 class methodsFor:'initialization'!

initialize
    super initialize.

    "Created: / 09-05-2011 / 23:20:44 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 10-05-2011 / 14:40:08 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaClassReader2 methodsFor:'file reading - constants'!

readConstantPool
    | constantPoolSize  const |

    "/
    "/ get constant pool
    "/
    constantPoolSize := inStream nextUnsignedShortMSB: msb.
    self info: 'constantPoolSize = ' , constantPoolSize printString.
    constants := JavaConstantPool new: constantPoolSize - 1.
    constSlot := 1.
    [ constSlot < constantPoolSize ] whileTrue: [
            self info: 'const slot: ' , constSlot printString.
            const := self readConstant.
            constants at: constSlot put: const.
            
            "/ long & double consts take 2 slots
            "/ (only first is used)
            
            constNeeds2Slots 
                ifTrue: [ constSlot := constSlot + 2. ]
                ifFalse: [ constSlot := constSlot + 1. ]].
    constSlot := -1.
    
    1 to: constantPoolSize - 1
        do: 
            [:i | 
            | const  value |

            const := constants at: i.
            const ifNotNil: 
                    [ "/ kludge for 2-slot constants (which only take 1 slot in ST/X)
                    (const isKindOf: JavaUnresolvedConstant) 
                        ifTrue: 
                            [ value := const preResolve.
                            value ~~ const ifTrue: [ constants at: i put: value. ] ] ] ].

    "
     JavaClassReader readFile:'/phys/ibm3/hotjava/classes/browser/AddButton.class'
     JavaClassReader readFile:'/phys/ibm3/hotjava/classes/browser/Alignable.class'"

    "Modified: / 07-05-1998 / 11:44:06 / cg"
    "Created: / 13-05-2011 / 16:52:54 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

readConstant_Class
    | nameIndex |

    nameIndex := inStream nextUnsignedShortMSB: msb.
    ((constants at: nameIndex) isNil) 
        ifTrue: 
            [ self info: ('reading class; index=' , nameIndex printString , ' name=' 
                        , (constants at: nameIndex) printString) ]
        ifFalse: [ self info: ('reading class; index= ' , nameIndex printString) ].
    ^ JavaClassRef2 in: constants withNameAt: nameIndex.

    "Modified: / 18-05-2011 / 18:21:16 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

readConstant_Fieldref    
    "incrementally changing resolving logic, fields will come later"

    | classIndex  nameAndTypeIndex |

    classIndex := inStream nextUnsignedShortMSB: msb.
    nameAndTypeIndex := inStream nextUnsignedShortMSB: msb.
    self 
        info: 'reading fieldref; classindex=' , classIndex printString 
                , ' nameAndTypeIndex=' , nameAndTypeIndex printString.
    ^ JavaFieldRef2 
        in: constants
        withNameAndTypeAt: nameAndTypeIndex
        andClassAt: classIndex.

    "Modified: / 15-05-2011 / 14:20:23 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

readConstant_InterfaceMethodref
    | classIndex  nameAndTypeIndex  |

    classIndex := inStream nextUnsignedShortMSB: msb.
    nameAndTypeIndex := inStream nextUnsignedShortMSB: msb.    
    self 
        info: 'reading interface methodref; classindex=' , classIndex printString                 
                , ' nameAndTypeIndex=' , nameAndTypeIndex printString.                
    ^ JavaInterfaceMethodRef2 
        in: constants
        withNameAndTypeAt: nameAndTypeIndex
        andClassAt: classIndex.

    "Modified: / 12-05-2011 / 18:57:47 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

readConstant_Methodref
    | classIndex  nameAndTypeIndex   |

    classIndex := inStream nextUnsignedShortMSB: msb.
    nameAndTypeIndex := inStream nextUnsignedShortMSB: msb.   
    self 
        info: 'reading methodref; classindex=' , classIndex printString , ' nameAndTypeIndex=' 
                , nameAndTypeIndex printString.
    ^ JavaMethodRef2 
        in: constants
        withNameAndTypeAt: nameAndTypeIndex
        andClassAt: classIndex.

    "Modified: / 15-05-2011 / 14:20:38 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

readConstant_NameAndType
    | nameIndex  descriptorIndex |

    nameIndex := inStream nextUnsignedShortMSB: msb.
    descriptorIndex := inStream nextUnsignedShortMSB: msb.
    self 
        info: 'reading nameAndType; nameindex=' , nameIndex printString 
                , ' descriptorIndex= ' , descriptorIndex printString.
    ^JavaNameAndType2 
                in: constants
                withNameAt: nameIndex
                andDescriptorAt: descriptorIndex.

    "Modified: / 10-05-2011 / 17:09:47 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaClassReader2 methodsFor:'helpers'!

loadSuperclassIdentifiedBy: something ignoring: classesBeingLoaded 
    "overriding method, here we expect something to be new JavaClassRef2"

    self assert: something isJavaRef
        message: 'class identifier is not a java reference'.

    self assert: something isJavaClassRef
        message: 'class identifier is not a java class reference'.

    (classesBeingLoaded includes: something fullName) ifTrue: 
        [self error: 'class we want to load is being loaded and that means something went wrong. tell mh'].

    "Do NOT use >>something resolve<< here, since something
     has no owner set and therefore access check will cause DNU.
     Ask JV for details."

    ^Java classForName: something javaClassName.

    "Created: / 18-05-2011 / 14:55:32 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 22-05-2011 / 13:58:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!JavaClassReader2 class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !

JavaClassReader2 initialize!
