"{ Package: 'stx:libjava' }"

Object subclass:#JavaObjectDictionary
	instanceVariableNames:'dictionary'
	classVariableNames:'Instance'
	poolDictionaries:''
	category:'Languages-Java-Support'
!


!JavaObjectDictionary class methodsFor:'instance creation'!

instance
    Instance ifNil: [
        Instance := self basicNew initialize.
    ].
    ^ Instance.

    "Created: / 09-01-2011 / 20:48:16 / Jan Kurs <kurs.jan@post.cz>"
!

new 
    "Currently singleton but in future Query may be more suitable"
    ^ self instance.

    "Created: / 09-01-2011 / 20:48:16 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaObjectDictionary methodsFor:'accessing'!

hasReflection: stClassName
    "return true if stClassName has reflection in Java World"
    ^ (dictionary at: stClassName ifAbsent:  [ nil ]) notNil

    "Created: / 17-01-2011 / 19:20:58 / kursjan <kursjan@fit.cvut.cz>"
!

reflectionOf: stClassName
    ^ dictionary at: stClassName ifAbsent:  [ NoReflectionObject new ]

    "Created: / 09-01-2011 / 21:03:24 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 17-01-2011 / 10:39:43 / kursjan <kursjan@fit.cvut.cz>"
! !

!JavaObjectDictionary methodsFor:'adding & removing'!

flush
    dictionary removeAll.

    "Created: / 09-01-2011 / 21:44:04 / Jan Kurs <kurs.jan@post.cz>"
!

registerJavaObject: aJavaClass toStObject: aStObject
    dictionary at: aStObject name asSymbol put: aJavaClass.

    "Created: / 09-01-2011 / 21:40:00 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaObjectDictionary methodsFor:'initialization'!

initialize
    "Use StCounter instead of Counter"
    dictionary := IdentityDictionary new.

    "Modified: / 09-01-2011 / 21:36:58 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaObjectDictionary class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
